#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'lixiang'

import os
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from updateitem import Ui_UpdateItem


class UpdateListItemWidget(QWidget):

    app_msg = None
    size_change = pyqtSignal(str, bool)

    def __init__(self, appmsg, parent=None):
        QWidget.__init__(self,parent)
        self.setFixedSize(450, 34)
        self.app_msg = appmsg
        self.parent = parent
        self.ui_init()
        self.stylesheet_init()

    def ui_init(self):
        # self.setAutoFillBackground(True)
        # # self.setStyleSheet("QWidget{background:white}")
        # palette = QPalette()
        # palette.setColor(QPalette.Background, QColor(255,255,255))#ffffff
        # self.setPalette(palette)
        # self.show()
        self.checkBox = QCheckBox(self)
        self.logolabel = QLabel(self)
        self.logolabel.setFixedSize(24, 24)
        self.applabel = QLabel(self)
        self.applabel.setFixedWidth(120)
        self.versionlabel = QLabel(self)
        self.versionlabel.setFixedWidth(240)
        self.sizelabel = QLabel(self)
        self.splitlabel = QLabel(self)
        self.splitlabel.setGeometry(0, 33, self.width(), 1)

        main_layout = QHBoxLayout()
        main_layout.addWidget(self.checkBox)
        main_layout.addWidget(self.logolabel)
        main_layout.addWidget(self.applabel)
        main_layout.addWidget(self.versionlabel)
        main_layout.addStretch()
        main_layout.addWidget(self.sizelabel)
        main_layout.setSpacing(2)
        main_layout.setMargin(0)
        main_layout.setContentsMargins(0, 0, 0, 0)
        self.setLayout(main_layout)

    def stylesheet_init(self):
        self.checkBox.setFocusPolicy(Qt.NoFocus)
        self.checkBox.setCheckState(Qt.Checked)
        self.checkBox.setStyleSheet("QCheckBox{spacing: 2px;color:#666666;font-size:13px;}"\
                                       "QCheckBox:hover{background-color:rgb(238, 237, 240);}"\
                                       "QCheckBox::indicator{width: 12px;height: 12px;}"\
                                       "QCheckBox::indicator:unchecked{image: url(./res/checkbox_uncheck);}"\
                                       "QCheckBox::indicator:unchecked:hover{image: url(./res/checkbox_uncheck_hover);}"\
                                       "QCheckBox::indicator:unchecked:pressed{image: url(./res/checkbox_uncheck_hover);}"\
                                       "QCheckBox::indicator{width: 20px;height: 20px;}"\
                                       "QCheckBox::indicator:checked{image: url(./res/checkbox_check);}"\
                                       "QCheckBox::indicator:checked:hover{image: url(./res/checkbox_check_hover);}"\
                                       "QCheckBox::indicator:checked:pressed{image: url(./res/checkbox_check_hover);}")

        pixmap = QPixmap(self.app_msg.ICON)
        if pixmap.isNull():
            pixmap = QPixmap("./res/logo.png")
        self.logolabel.setPixmap(pixmap.scaled(QSize(24,24)))
        # self.applabel.setWordWrap(True)
        self.applabel.setStyleSheet("QLabel{font-size:13px;color:#666666;}")
        # self.applabel.setText(self.appmsg.NAME)
        metrics = QFontMetrics(self.applabel.font())
        elidedText = metrics.elidedText(self.app_msg.NAME, Qt.ElideRight, self.applabel.width())
        if elidedText.endsWith("…"):
            self.applabel.setToolTip(self.app_msg.NAME)
            self.applabel.setText(elidedText)
        else:
            self.applabel.setText(elidedText)
        self.sizelabel.setStyleSheet("QLabel{font-size:13px;color:#666666;}")
        self.sizelabel.setText(self.app_msg.SIZE)
        self.splitlabel.setStyleSheet("QLabel{background:#aaaaaa;}")
        self.versionlabel.setStyleSheet("QLabel{font-size:13px;color:#f97150;}")
        alltext = QString("%1 -> %2 ").arg(self.app_msg.INSTALLEDVERSION).arg(self.app_msg.CANDIDATEVERSION)
        metrics = QFontMetrics(self.versionlabel.font())
        # aa = self.width() - self.checkBox.width() - self.logolabel.width() - self.applabel.width() - self.sizelabel.width() - 5*4
        elidedText = metrics.elidedText(alltext, Qt.ElideRight, self.versionlabel.width())
        if elidedText.endsWith("…"):
            tmp_list = elidedText.split(" ")
            self.versionlabel.setToolTip(alltext)
            self.versionlabel.setText(elidedText)
        else:
            self.versionlabel.setText(elidedText)
        # self.connect(self.checkBox, SIGNAL("toggled(bool)"), self, SIGNAL("synCheckBoxState(bool)"))
        self.checkBox.toggled.connect(self.slot_toggle_cb)
        # self.connect(self.checkBox, SIGNAL("toggled(bool)"), self, SLOT("synItemContext()"))

    def get_checkbox_status(self):
        return self.checkBox.isChecked()

    def slot_toggle_cb(self):
        if self.checkBox.isChecked():
            self.size_change.emit(self.statusTip(), True)
        else:
            self.size_change.emit(self.statusTip(), False)